# PPCSnowLeopardPorts
a local repository of MacPorts that are configured for an installation of SnowLeopard for PPC and shadow newer incompatible versions of ports

SnowLeopard for PPC is an early version of SnowLeopard that ran on PowerPC hardware, prior to the official release of SnowLeopard that was Intel-architecture only

To allow MacPorts to work on this nonstandard system do the following:

add these lines to the top of /opt/local/etc/macports/macports.conf
```
build_arch              ppc
universal_archs
buildfromsource         always
cxx_stdlib              libstdc++
```

disable archive sites here /opt/local/etc/macports/archive_sites.conf
```
$ diff -u archive_sites.conf.default archive_sites.conf
--- archive_sites.conf.default    2021-08-22 14:16:52.000000000 -0700
+++ archive_sites.conf    2021-08-22 14:21:54.000000000 -0700
@@ -52,4 +52,4 @@

# To disable the default archive source, uncomment the following dummy
# entry; it will shadow the one from the ports tree.
-#name                    macports_archives
+name                    macports_archives
```
use the older sandboxing code for leopard by making this change:
```
$ diff -u /opt/local/libexec/macports/lib/port1.0/portsandbox.tcl.orig /opt/local/libexec/macports/lib/port1.0/portsandbox.tcl
--- /opt/local/libexec/macports/lib/port1.0/portsandbox.tcl.orig    2021-09-01 15:47:07.000000000 -0700
+++ /opt/local/libexec/macports/lib/port1.0/portsandbox.tcl    2021-08-29 19:33:28.000000000 -0700
@@ -121,7 +121,7 @@
     foreach dir $allow_dirs {
         foreach perm $perms {
             append portsandbox_profile " (allow $perm ("
-            if {${os.major} > 9} {
+            if {${os.major} > 10} {
                 append portsandbox_profile "subpath \"${dir}\"))"
             } else {
                 append portsandbox_profile "regex #\"^${dir}/\"))"
```

download this overlay repo to /opt/PPCSnowLeopardPorts, and use it by making this change in this file
```
/opt/local/etc/macports/sources.conf

$ diff -u /opt/local/etc/macports/sources.conf.default /opt/local/etc/macports/sources.conf
--- /opt/local/etc/macports/sources.conf.default    2021-08-22 14:16:52.000000000 -0700
+++ /opt/local/etc/macports/sources.conf    2021-08-24 00:30:40.000000000 -0700
@@ -27,4 +27,7 @@
# sites, etc.), the primary MacPorts source must always be tagged
# "[default]", even if switched from the default "rsync://" URL.

+# override repo
+file:///opt/PPCSnowLeopardPorts
+
rsync://rsync.macports.org/macports/release/tarballs/ports.tar [default]
```

force the main MacPorts portfile repo to use the new compiler selection by doing this after every "sudo port -v sync"
```
$ sudo mv /opt/local/var/macports/sources/rsync.macports.org/macports/release/tarballs/ports/_resources/port1.0/compilers /opt/local/var/macports/sources/rsync.macports.org/macports/release/tarballs/ports/_resources/port1.0/compilers-moved
$ sudo ln -s /opt/PPCSnowLeopardPorts/_resources/port1.0/compilers /opt/local/var/macports/sources/rsync.macports.org/macports/release/tarballs/ports/_resources/port1.0/compilers
```

and you should be good to go. Hundreds of ports will build. Some may not.
